public final class StringDuplicateDeleter extends DuplicateDeleter<String> {
    
    public StringDuplicateDeleter(String[] array){
        super(array);
    }

    public String[] removeDuplicates(int maxNumberOfDuplications){
        StringBuilder remover = new StringBuilder();
        for(int i=0; i<array.length; i++){
            if(countDuplicates(i) < maxNumberOfDuplications){
                remover.append(array[i]+"#");
            }
        }
        String[] parts = remover.toString().split("#");
        String[] removed;
        if(parts[0].equals("")){
            removed= new String[]{};
        }else{
            removed= parts;
        }
        return removed;
    }

    public String[] removeDuplicatesExactly(int exactNumberOfDuplications){
        StringBuilder remover = new StringBuilder();
        for(int i=0; i<array.length; i++){
            if(countDuplicates(i) != exactNumberOfDuplications){
                remover.append(array[i]+"#");
            }
        }
        String[] parts = remover.toString().split("#");
        String[] removed;
        if(parts[0].equals("")){
            removed= new String[]{};
        }else{
            removed = parts;
        }
        return removed;

    }
    public int countDuplicates(int i){
        int dupes = 0;
        for(int j=0; j<array.length; j++){
            if(array[i] == array[j]){
                dupes++;
            }
        }
        return dupes;
    } 
}